#include <iostream>
//#include <string>
//#include <iomanip>
//#include <cstdlib>
#include <set>
#include <queue>
//#include <cmath>
//#include <cstring>

using namespace std;

int pole[10];
int size;
unsigned long int limit_d;
unsigned long int limit_h;

set<unsigned long int> vystup;
set<unsigned long int>::iterator it;

class Objekt
{
  public:
  unsigned long int soucin_vcetne;
  int index;
  Objekt(const unsigned long int sv,const int ind)
    : soucin_vcetne(sv) , index(ind)
  {}
  Objekt(const Objekt& o)
    : soucin_vcetne(o.soucin_vcetne) , index(o.index)
    {}
    Objekt& operator=(const Objekt& o)
    {
    soucin_vcetne=o.soucin_vcetne;
    index=o.index;
    return *this;
    }
  bool operator < (const Objekt& o) const
  {
    return soucin_vcetne >= o.soucin_vcetne ;
  }
};

priority_queue<Objekt> fronta;

bool vytisknuto;

void f(Objekt o)
{
  if(o.soucin_vcetne>limit_h)
    return;
  if(o.soucin_vcetne>=limit_d)
  {
    if(vytisknuto)
      cout << ',';
    cout << o.soucin_vcetne;
    vytisknuto = true;
  }
  for(int i = o.index;i<size;i++)
  {
    fronta.push(Objekt(o.soucin_vcetne*pole[i],i));
  }
}




int main()
{
  while(true)
  {
    vytisknuto = false;
    cin>>size;
    if(size==0)
      break;
    for(int i=0;i<size;i++)
      cin >> pole[i];
    cin >> limit_d >> limit_h;
    while(!fronta.empty())
      fronta.pop();
    if(limit_d<=1)
    {
      cout << '1';
      vytisknuto=true;
    }
    for(int i = 0;i<size;i++)
      fronta.push(Objekt(pole[i],i));

    while(!fronta.empty())
    {
      f(fronta.top());
      fronta.pop();
    }
    
    if(!vytisknuto)
      cout << "none"<<endl;
    else cout<<endl;    
  }
  return 0;
}
